/*
    This file is part of Kismet

    Kismet is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Kismet is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Kismet; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __PACKETFORGE_H__
#define __PACKETFORGE_H__

#include "config.h"

#ifdef HAVE_STDINT_H
#include <stdint.h>
#endif
#ifdef HAVE_INTTYPES_H
#include <inttypes.h>
#endif

// Forge a random mac within a reasonable OUI
void PacketForgeCreateRandmac(uint8_t *addr);

// Forge a deauthentication packet
int PacketForgeDeauth(uint8_t *in_bssid, uint8_t *in_source, 
                      uint8_t *in_dest, uint8_t **ret_frame);

// Forge a disassoc
int PacketForgeDisassoc(uint8_t *in_bssid, uint8_t *in_source,
                        uint8_t *in_dest, uint8_t **ret_frame);

// Forge an association
int PacketForgeAssocReq(uint8_t *in_bssid, uint8_t *in_source, const char *in_ssid,
                        int in_wep, uint8_t **ret_frame);

// Forge an auth frame
int PacketForgeAuth(uint8_t *in_source, uint8_t *in_dest, uint8_t **ret_frame);

// Forge a probe request
int PacketForgeProbeReq(uint8_t *in_source, const char *in_ssid, uint8_t **ret_frame);

#endif

