/*
    This file is part of Kismet

    Kismet is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Kismet is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Kismet; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __TCPHEARTSERVER_H__
#define __TCPHEARTSERVER_H__

#include "config.h"

#include <time.h>

#include "tcpserver.h"

// Basic heartbeat server that just tracks that someone is sending it
// heartbeats.  Part of a simple secondary monitoring system
class TcpHeartServer : public TcpServer {
public:
    // We're almost entirely a pure tcp server
    TcpHeartServer();
    virtual ~TcpHeartServer();

    // Fetch the last heartbeat from any client
    virtual time_t FetchLastBeat() {
        return last_beat;
    }

protected:
    // We actually handle parsing data
    virtual int ParseData(int in_fd);

    // Last time we got a heartbeat
    time_t last_beat;
};

#endif

